#! /usr/bin/perl
use strict;

my %AS;
               use coqm;
               my $rh_session = coqm::create_session($ARGV[1], $ARGV[0] );
               #my $rh_ifDescr = coqm::fetch_ifDescr();
               my $rh_Peers = coqm::fetch_bgpPeerIdentifier();

               foreach my $peer_ip (sort { $a <=> $b } (keys %{$rh_Peers}) )
               {
			my $as = coqm::fetch_bgpPeerRemoteAs( $peer_ip );
			my $state = coqm::fetch_bgpPeerState( $peer_ip );
			my $version = coqm::fetch_bgpPeerNegotiatedVersion( $peer_ip );
			my $laddr = coqm::fetch_bgpPeerLocalAddr( $peer_ip );
			my $uptime = coqm::fetch_bgpPeerFsmEstablishedTime( $peer_ip );
			my $InUpdates = coqm::fetch_bgpPeerInUpdates( $peer_ip );
			my $OutUpdates = coqm::fetch_bgpPeerOutUpdates( $peer_ip );
			my $InMessages = coqm::fetch_bgpPeerInTotalMessages( $peer_ip );
			my $OutMessages = coqm::fetch_bgpPeerOutTotalMessages( $peer_ip );
			$AS{ $as }{ $peer_ip }{ 'state' } = $state;
			$AS{ $as }{ $peer_ip }{ 'version' } = $version;
			$AS{ $as }{ $peer_ip }{ 'uptime' } = $uptime;
			$AS{ $as }{ $peer_ip }{ 'laddr' } = $laddr;
			$AS{ $as }{ $peer_ip }{ 'InUpdates' } = $InUpdates;
			$AS{ $as }{ $peer_ip }{ 'OutUpdates' } = $OutUpdates;
			$AS{ $as }{ $peer_ip }{ 'InMessages' } = $InMessages;
			$AS{ $as }{ $peer_ip }{ 'OutMessages' } = $OutMessages;
               }

foreach my $as (sort { $a <=> $b } (keys %AS))
{
	print "AS $as\n";
	foreach my $peer (sort { $a <=> $b } (keys %{ $AS{$as} }) )
	{
		print "\tPeer: $peer\n";
		foreach my $item ( 'state', 'version', 'uptime' , 'laddr', 'InUpdates', 'OutUpdates', 'InMessages', 'OutMessages' )
		{
			printf "\t\t%-16s %-s\n", $item, $AS{$as}{$peer}{$item};
		}
	}
}
