#! /usr/bin/perl
use strict;

use coqm;
my $rh_session = coqm::create_session($ARGV[1], $ARGV[0] );
my $rh_ifDescr = coqm::fetch_ifDescr();
my $rh_mroutes = coqm::fetch_ipMRouteInIfIndex();
my $rh_nexthops = coqm::fetch_ipMRouteNextHopState();

foreach my $grp (sort { $a <=> $b } (keys %{$rh_mroutes}) )
{
	print "Group: ( *, $grp )\n";
	foreach my $src (sort { $a <=> $b } (keys %{$$rh_mroutes{ $grp }}) )
	{
		foreach my $msk (sort { $a <=> $b } (keys %{$$rh_mroutes{ $grp }{$src }}) )
		{
			my $ifindex = $$rh_mroutes{ $grp }{ $src }{ $msk };
			my $ifDescr = $$rh_ifDescr{ $ifindex };
			my $ifName = coqm::fetch_ifName( $ifindex );
			my $nexthop = coqm::fetch_ipMRouteUpstreamNeighbor( $grp, $src, $msk  );
			my $uptime = coqm::fetch_ipMRouteUpTime( $grp, $src, $msk  );
			my $exptime = coqm::fetch_ipMRouteExpiryTime( $grp, $src, $msk  );
			my $inPkts = coqm::fetch_ipMRoutePkts( $grp, $src, $msk  );
			my $inOcts = coqm::fetch_ipMRouteOctets( $grp, $src, $msk  );
			print "\t( $src, $grp ), $uptime/$exptime\n";
			print "\t\tIncoming interface: $ifDescr, RPF nbr $nexthop, $inPkts Pkts In / $inOcts In Octs\n";
			
			print "\t\tOutgoing interface list:\n";
			foreach my $dst_ifindex ( keys %{ $$rh_nexthops{ $grp }{ $src }{ $msk } } )
			{
				my $dst_ifDescr = $$rh_ifDescr{ $dst_ifindex };
				my $dst_ifName = coqm::fetch_ifName( $dst_ifindex );
				foreach my $dst_addr ( keys %{ $$rh_nexthops{ $grp }{ $src }{ $msk }{ $dst_ifindex } } )
				{
					my $state = $$rh_nexthops{ $grp }{ $src }{ $msk }{ $dst_ifindex }{ $dst_addr };
					my $pkts = coqm::fetch_ipMRouteNextHopPkts( $grp, $src, $msk, $dst_ifindex, $dst_addr );
					my $proto = coqm::fetch_ipMRouteNextHopProtocol( $grp, $src, $msk, $dst_ifindex, $dst_addr );
					my $uptime = coqm::fetch_ipMRouteNextHopUpTime( $grp, $src, $msk, $dst_ifindex, $dst_addr );
					my $exptime = coqm::fetch_ipMRouteNextHopExpiryTime( $grp, $src, $msk, $dst_ifindex, $dst_addr );
					print "\t\t\t$dst_ifDescr $state/$proto, $uptime/$exptime, $pkts Pkts Out\n";
				}
			}
			
		}
	}
}
